#---------------------------------------------------------------------------------
# Check Parameters
#---------------------------------------------------------------------------------

if [ $# -ne 2 ]
then
    echo "Usage: $0 <binutils source dir> <installation dir>"
    exit 1
fi

SRCDIR=$1              #$1 is the source code dir for binutils
prefix=$2              #$2 is the installation dir


#---------------------------------------------------------------------------------
# set the target and compiler flags
#---------------------------------------------------------------------------------

target=arm-elf

export CFLAGS='-O2 -pipe'
export CXXFLAGS='-O2 -pipe'
export LDFLAGS='-s'
export DEBUG_FLAGS=''


#---------------------------------------------------------------------------------
# Build and install binutils
#---------------------------------------------------------------------------------

mkdir -p $target/binutils
cd $target/binutils

$SRCDIR/configure --prefix=$prefix --target=$target \
    --disable-nls --disable-shared --enable-debug --disable-threads \
    --with-gcc --with-gnu-as --with-gnu-ld --with-stabs\
    --enable-interwork --enable-multilib\
    2>&1 | tee r5_configure.log

make	all 2>&1 | tee r5_make.log
make	install 2>&1 | tee r5_install.log
