#---------------------------------------------------------------------------------
# Check Parameters
#---------------------------------------------------------------------------------

if [ $# -ne 2 ]
then
    echo "Usage: $0 <gcc source dir> <installation dir>"
    exit 1
fi

SRCDIR=$1               #$1 is the source code dir for gcc
prefix=$2               #$2 is the install directory

#---------------------------------------------------------------------------------
# set the target and compiler flags
#---------------------------------------------------------------------------------

target=arm-elf


export PATH=${PATH}:$prefix/bin


#---------------------------------------------------------------------------------
# build and install just the c compiler
#---------------------------------------------------------------------------------

mkdir -p $target/gcc
cd $target/gcc


$SRCDIR/configure \
	--enable-languages=c,c++ \
	--with-cpu=arm7tdmi\
	--enable-interwork --enable-multilib\
	--with-gcc --with-gnu-ld --with-gnu-as --with-stabs \
	--disable-shared --disable-threads --disable-win32-registry --disable-nls\
	--target=$target \
	--with-newlib \
	--prefix=$prefix -v\
	2>&1 | tee r5_configure.log

make all-gcc | tee r6_make-c-only.log 2>&1
make install-gcc | tee r6_install-c-only.log 2>&1
