#---------------------------------------------------------------------------------
# Check Parameters
#---------------------------------------------------------------------------------

if [ $# -ne 2 ]
then
    echo "Usage: $0 <newlib source dir> <installation dir>"
    exit 1
fi

SRCDIR=$1               #$1 is the source code dir for newlib
prefix=$2               #$2 is the installation directory


#---------------------------------------------------------------------------------
# set target and compiler flags
#---------------------------------------------------------------------------------

target=arm-elf

#---------------------------------------------------------------------------------
# Build and install newlib
#---------------------------------------------------------------------------------

mkdir -p $target/newlib
cd $target/newlib

$SRCDIR/configure\
	--target=$target --prefix=$prefix \
	2>&1 | tee r5_configure.log

make all 2>&1 | tee r5_make.log
make install 2>&1 | tee r5_install.log
