if [ $# -ne 2 ]
then
    echo "Usage: $0 <gcc source dir> <installation dir>"
    exit 1
fi

SRCDIR=$1              #$1 is the source code dir for gcc
prefix=$2              #$2 is the installation dir

target=powerpc-elf


mkdir -p $target/gcc
cd $target/gcc

$SRCDIR/configure \
	--enable-languages=c,c++ \
	--with-cpu=750\
	--with-gcc --with-gnu-ld --with-gnu-as --with-stabs \
	--disable-nls --disable-shared --disable-threads --disable-multilib\
	--disable-win32-registry\
	--target=$target \
	--with-newlib \
	--prefix=$prefix -v\
	2>&1 | tee configure.log

make all-gcc | tee c-only_make.log 2>&1
make install-gcc | tee c-only_install.log 2>&1
